package com.gxwebsoft.shop.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gxwebsoft.shop.mapper.UserCouponMapper;
import com.gxwebsoft.shop.service.UserCouponService;
import com.gxwebsoft.shop.entity.UserCoupon;
import com.gxwebsoft.shop.param.UserCouponParam;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.PageResult;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 用户优惠券记录表Service实现
 *
 * @author 科技小王子
 * @since 2022-11-25 19:04:43
 */
@Service
public class UserCouponServiceImpl extends ServiceImpl<UserCouponMapper, UserCoupon> implements UserCouponService {

    @Override
    public PageResult<UserCoupon> pageRel(UserCouponParam param) {
        PageParam<UserCoupon, UserCouponParam> page = new PageParam<>(param);
        //page.setDefaultOrder("create_time desc");
        List<UserCoupon> list = baseMapper.selectPageRel(page, param);
        return new PageResult<>(list, page.getTotal());
    }

    @Override
    public List<UserCoupon> listRel(UserCouponParam param) {
        List<UserCoupon> list = baseMapper.selectListRel(param);
        // 排序
        PageParam<UserCoupon, UserCouponParam> page = new PageParam<>();
        //page.setDefaultOrder("create_time desc");
        return page.sortRecords(list);
    }

    @Override
    public UserCoupon getByIdRel(Integer userCouponId) {
        UserCouponParam param = new UserCouponParam();
        param.setUserCouponId(userCouponId);
        return param.getOne(baseMapper.selectListRel(param));
    }

}
